--- qmail-1.03/dns.c	Mon Jun 15 12:53:16 1998
+++ qmail-fuckverisign/dns.c	Tue Sep 16 16:26:13 2003
@@ -18,6 +18,8 @@
 #include "dns.h"
 #include "case.h"
 
+#define FUCKVERISIGN 1
+
 static unsigned short getshort(c) unsigned char *c;
 { unsigned short u; u = c[0]; return (u << 8) + c[1]; }
 
@@ -263,6 +265,10 @@
  return DNS_HARD;
 }
 
+#ifdef FUCKVERISIGN
+static stralloc tld = {0};
+#endif
+
 static int dns_ipplus(ia,sa,pref)
 ipalloc *ia;
 stralloc *sa;
@@ -270,6 +276,10 @@
 {
  int r;
  struct ip_mx ix;
+#ifdef FUCKVERISIGN
+ int j;
+ struct ip_address tldip;
+#endif
 
  if (!stralloc_copy(&glue,sa)) return DNS_MEM;
  if (!stralloc_0(&glue)) return DNS_MEM;
@@ -280,8 +290,29 @@
      if (!ipalloc_append(ia,&ix)) return DNS_MEM;
      return 0;
     }
+
  }
 
+#ifdef FUCKVERISIGN
+   j = byte_rchr(sa->s,sa->len,'.');
+   if (j+2 < sa->len) {
+     if(!stralloc_copys(&tld, "*")) return DNS_MEM;
+     if(!stralloc_catb(&tld, sa->s+j, sa->len-j)) return DNS_MEM;
+     switch(resolve(&tld,T_A))
+     {
+       case DNS_HARD: byte_zero(&tldip, sizeof(tldip)); break;
+       case DNS_MEM: return DNS_MEM;
+       case DNS_SOFT: return DNS_SOFT;
+       default:
+         while ((r = findip(T_A)) != 2)
+         {
+           if (r == DNS_SOFT) return DNS_SOFT;
+           if (r == 1) tldip = ip;
+         }
+     }
+   }
+#endif
+
  switch(resolve(sa,T_A))
   {
    case DNS_MEM: return DNS_MEM;
@@ -293,8 +324,12 @@
    ix.ip = ip;
    ix.pref = pref;
    if (r == DNS_SOFT) return DNS_SOFT;
-   if (r == 1)
+   if (r == 1) {
+#ifdef FUCKVERISIGN
+     if (byte_diff(&tldip, sizeof(tldip), &ip) == 0) continue;
+#endif
      if (!ipalloc_append(ia,&ix)) return DNS_MEM;
+   }
   }
  return 0;
 }
